from CvPythonExtensions import *
import FFHSpells #needed by the spells that are evaled
import Popup as PyPopup
import CvScreensInterface
import sys
#import CyMessageControl2
gc = CyGlobalContext()
def cast(argsList):
	pCaster, eSpell = argsList
	spell = gc.getSpellInfo(eSpell)
	point = pCaster.plot().getPoint()
	if gc.getGame().getActivePlayer() == pCaster.getOwner() and pCaster.plot().isVisibleToWatchingHuman():
		if(spell.getEffect() != -1):
			CyEngine().triggerEffect(spell.getEffect(),point)
		if(spell.getSound() !=None):
			CyAudioGame().Play3DSound(spell.getSound(),point.x,point.y,point.z)
	eval(spell.getPyResult())
	CyInterface().setDirty(InterfaceDirtyBits.SelectionButtons_DIRTY_BIT, True)
	FFHSpells.clearTarget()
def castAt(argsList):
	pCaster, eSpell, pX, pY = argsList
	
	pPlot = CyMap().plot(pX,pY)
	numTargets = gc.getSpellInfo(eSpell).getRangeSelectNum()
	if numTargets <=0:
		castAtFinal(pCaster,eSpell,pPlot)
		return
	if not gc.getPlayer(pCaster.getOwner()).isHuman():
		castAtUnit(pCaster, eSpell, [FFHSpells.getUnitTarget()])
		FFHSpells.clearTarget()
	elif gc.getGame().getActivePlayer() == pCaster.getOwner():
		units = getTargets(pCaster,eSpell,pPlot)
		CvScreensInterface.showTargetScreen(units,numTargets,(pCaster,eSpell))
def targetPicked(pTarget, userData):#called by CvPickTargetScreen.handleInput
	#castAtFinal(userData[0],userData[1],pTarget)
	for u in pTarget:
		#CyMessageControl2().sendDoCommand(userData[0].getID(),CommandTypes.COMMAND_CAST_AT_UNIT_PICK,u.getOwner(),u.getID(),False)
		CyGame().selectionListGameNetMessage(GameMessageTypes.GAMEMESSAGE_DO_COMMAND,CommandTypes.COMMAND_CAST_AT_UNIT_PICK,u.getOwner(), u.getID(),0,false,false)
	#CyMessageControl2().sendDoCommand(userData[0].getID(),CommandTypes.COMMAND_CAST_AT_UNIT,userData[1],-1,False)
	CyGame().selectionListGameNetMessage(GameMessageTypes.GAMEMESSAGE_DO_COMMAND,CommandTypes.COMMAND_CAST_AT_UNIT,userData[1],-1,0,false,false)
targets = []
def castAtUnit(argsList):
	pCaster, eSpell= argsList
	global targets
	castAtFinal(pCaster,eSpell,targets)
	targets = []
def castAtUnitPick(argsList):
	owner, id = argsList
	global targets
	targets.append(gc.getPlayer(owner).getUnit(id))
def castAtFinal(pCaster,eSpell,pTarget):
	spell = gc.getSpellInfo(eSpell)
	point = pCaster.plot().getPoint()
	if pCaster.plot().isVisibleToWatchingHuman():
		if(spell.getEffect() != -1):
			CyEngine().triggerEffect(spell.getEffect(),point)
		if(spell.getSound() !=None):
			CyAudioGame().Play3DSound(spell.getSound(),point.x,point.y,point.z)
	eval(spell.getPyResult())
	CyInterface().setDirty(InterfaceDirtyBits.SelectionButtons_DIRTY_BIT, True)
	FFHSpells.clearTarget()
	
def canCast(argsList):
	pCaster, eSpell = argsList
	spell = gc.getSpellInfo(eSpell)
	req = spell.getPyRequirement()
	if(req == None or req == ""): 
		return True
	return eval(req)
def getTargets(pCaster,eSpell,pPlot):
	spell = gc.getSpellInfo(eSpell)
	req = spell.getPyValidUnitTargets()
	if(req == None or req == ""): 
		return []
	return eval(req)
	
def canCastAt(argsList):
	pCaster, eSpell, pX, pY = argsList	
	pPlot = CyMap().plot(pX,pY)
	numTargets = gc.getSpellInfo(eSpell).getRangeSelectNum()
	if numTargets==0:
		return len(getTargets(pCaster,eSpell,pPlot)) > 0 
	else:
		return len(getTargets(pCaster,eSpell,pPlot)) >= numTargets

def getAIWeight(argsList):
	pCaster, eSpell = argsList
	spell = gc.getSpellInfo(eSpell)
	w = spell.getPyAIWeight()
	if(w == None or w == ""): 
		return 0
	return eval(w)
def AI_getTargets(argsList):
	pCaster, eSpell, pPlot = argsList
	ulist = getTargets(pCaster, eSpell, pPlot)
	ids = []
	for u in ulist:
		ids.append(u.getID())
	return ids
#Says whether the spell should be displayed (disabled) for this caster,
#even though the python says it can't be cast. Is called for every
#spell that meets the promotion requirements, but not the python ones.
#perhaps there should be another XML py___ tag for this.
def displayWhenDisabled(argsList):
	pCaster, eSpell = argsList
	return FFHSpells.canDisabledCast(pCaster,eSpell)

def setUnitTarget(argsList):
	FFHSpell.unitTarget(argsList[0])
def setTarget(argsList):
	FFHSpells.target(argsList[0])