## this is a simple helper program which allows you to quickly do adjustments 
## throughout an entire xml file, such as "multiply all melee flavors by 5".
## Yes, I like DOM better than sax. ;)
##                                                        --Bringa


## USAGE: python adjustXML.py <filename> > <targetfilename>

import sys
import xml.dom.minidom as mdom

fname = sys.argv[1]

dom = mdom.parse(fname)

changeThis = "FLAVOR_MELEE"

iFlavors = dom.documentElement.getElementsByTagName("iFlavor")

for flavor in iFlavors:
    ftype = flavor.parentNode.childNodes[1].firstChild.toxml()
    if ftype == changeThis:
        oldValue = int(flavor.firstChild.nodeValue)
        newValue = oldValue * 3
        if newValue > 50:
            newValue = 51
        if newValue < -50:
            newValue = -51
        flavor.firstChild.nodeValue = newValue
    
print dom.toprettyxml()
    